<?php
/**
 * Created by PhpStorm.
 * User: Noa
 * Date: 12/10/2017
 * Time: 06:03
 */

namespace Retailmenot\Lab\Middleware\middlewares;


use Interop\Http\Server\MiddlewareInterface;
use Interop\Http\Server\RequestHandlerInterface;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Retailmenot\Lab\Middleware\controllers\AppController;

class AppMiddleware implements MiddlewareInterface
{

    /**
     * Process an incoming server request and return a response, optionally delegating
     * response creation to a handler.
     *
     * @param ServerRequestInterface $request
     * @param RequestHandlerInterface $handler
     *
     * @return ResponseInterface
     */
    public function process(ServerRequestInterface $request, RequestHandlerInterface $handler)
    {
        $response = $handler->handle($request);

        $app = new AppController($request, $response);
        $response = $app->run();

        return $response;
    }
}