<?php
/**
 * Created by PhpStorm.
 * User: Noa
 * Date: 10/10/2017
 * Time: 13:28
 */

namespace Retailmenot\Lab\Middleware\middlewares;


use Psr\Http\Message\RequestInterface;
use Psr\Http\Message\ResponseInterface;

class DummyMiddleware1
{
    /**
     * @param RequestInterface $request
     * @param ResponseInterface $response
     * @param callable|null $next
     * @return ResponseInterface|static
     */
    public function __invoke(RequestInterface $request, ResponseInterface $response, callable $next=null) {

        $response = $response->withHeader('X-RMN-DummyMiddleware', 'I was here : dummy middleware');

        if (is_callable($next)) {

            $response = $next($request, $response);
        }

        return $response;
    }
}